const system = require("../../../system");
const Dao = require("../../dao.base");
class OrderProductDao extends Dao {
  constructor() {
    super(Dao.getModelName(OrderProductDao));
  }
  async getItemByOrderNo(orderNo, uapp_id) {
    return await this.model.findOne({
      where: {
        sourceOrderNo: orderNo, uapp_id: uapp_id
      },
      attributes: [
        "sourceOrderNo",
        "productType_id",
        "pathCode",
        "itemCode",
        "itemName",
        "channelItemCode",
        "channelItemName",
        "serviceItemCode",
        "picUrl",
        "proPrice",
        "quantity"],
      raw: true
    });
  }
}
module.exports = OrderProductDao;
