const system = require("../../../system");
// const Dao = require("../../dao.base");
const ServiceBase = require("../../sve.base");
const uuidv4 = require('uuid/v4');
class OrderInfoService extends ServiceBase {
  constructor() {
    super("dbcorder", ServiceBase.getDaoName(OrderInfoService));
    this.flowlogDao = system.getObject("db.dbcorder.flowlogDao");
    this.orderproductDao = system.getObject("db.dbcorder.orderproductDao");
    this.ordercontactsDao = system.getObject("db.dbcorder.ordercontactsDao");
    this.orderReceiptVoucherDao = system.getObject("db.dbcpay.orderreceiptvoucherDao");
    this.moneyJourneyDao = system.getObject("db.dbcpay.moneyjourneyDao");

  }
  async createOrder(pobj, orderNo, t) {
    var actionBody = pobj.actionBody;
    var channelOrder = actionBody.channelOrder;
    var orderContact = actionBody.orderContact;
    var price_item = actionBody.product_info.price_item;
    var totalServiceCharge = Number(price_item.service_charge || 0) * Number(actionBody.quantity);
    var totalPublicExpense = Number(price_item.public_expense || 0) * Number(actionBody.quantity);
    var totalProfitSum = Number(actionBody.totalSum) - (Number(price_item.supply_price || 0) * Number(actionBody.quantity));
    var pfProfitSum = (100 - Number(price_item.channel_profit_rate || 0)) / 100 * totalProfitSum;
    if (pfProfitSum < 0) {
      pfProfitSum = 0;
    }
    var channelProfitSum = Number(totalProfitSum) - Number(pfProfitSum);
    var payTime = channelOrder.payTime || new Date();
    var params = {
      uapp_id: pobj.appInfo.uapp_id,//int(11)       //                                                                                                                                                                                     
      orderNo: orderNo,//varchar(64)   //订单号                                                                                                                                                                                        
      channelServiceNo: channelOrder.channelServiceNo || orderNo,//varchar(64)   //渠道服务单号                                                                                                                                                                               
      channelOrderNo: channelOrder.channelOrderNo || orderNo,//varchar(1024) //渠道订单号列表，多个以,隔开                                                                                                                                                         
      needNo: channelOrder.needNo || "",//需求号--用于服务商或需求表中创建订单   
      channelUserId: pobj.userInfo.channel_userid,//varchar(64)   //                                                                                                                                                                                                 
      ownerUserId: pobj.userInfo.channel_userid,//varchar(20)   //                                                                                                                                                                                                 
      payTime: channelOrder.orderStatus && channelOrder.orderStatus == 2 ? payTime : null,//datetime      //                                                                                                                                                                                                 
      quantity: actionBody.quantity,//int(11)       //项目订单数量（即服务项目的倍数，默认值为1）                                                                                                                                 
      serviceQuantity: 0,//int(11)       //项目订单交付数量（即与项目订单数量相对应）                                                                                                                                                                                                   
      orderStatus: channelOrder.orderStatus || 1,//int          //订单状态: 1: 待付款, 2: 已付款, 4: 待服务, 8: 已完成
      totalSum: actionBody.totalSum,//decimal(12,2) //订单总额(产品价格×优惠费率×订单件数)                                                                                                                                           
      payTotalSum: actionBody.payTotalSum || actionBody.totalSum,//decimal(12,2) //                                                                                                                                                                                                 
      refundSum: 0,//decimal(12,2) //退款总额
      totalServiceCharge: totalServiceCharge,//decimal(12,2) //服务费总额（产品配置的服务费*订单件数）                                                                                                                                       
      totalPublicExpense: totalPublicExpense,//decimal(12,2) //官费总额（产品配置的官费*订单件数）   
      totalProfitSum: totalProfitSum,//decimal(12,2) //订单毛利润总额（产品价格-供货价格））  
      pfProfitSum: pfProfitSum,//decimal(12,2) //订单平台毛利润总额（(100-渠道利润分成比例)/100 * 订单毛利润总额）                                                                                                         
      channelProfitSum: channelProfitSum,//decimal(12,2) //订单渠道分成毛利润总额(订单毛利润总额-平台毛利润总额)  

      totalDiscounts: 0,//decimal(12,2) //优惠总额（（服务费总额+官费总额）-订单总额(产品价格×优惠费率×订单件数)>0则有优惠额度）暂时没有用到                                                                                                                                                    
      pfSettleProfit: 0,//int(11)       //平台结算渠道利润,0否，1是                                                                                                                                                             
      invoiceApplyStatus: "00",//varchar(10)   //发票状态:00: 未申请, 10: 已申请,20:已开票                                                                                                                                           
      notes: actionBody.notes || "",//varchar(255)  //                                                                                                                                                                                                 
      opNotes: "",//varchar(255)  //操作备注       
    };
    var order = await this.dao.create(params, t);//创建订单
    var orderLog = {
      uapp_id: pobj.appInfo.uapp_id,
      sourceOrderNo: orderNo,
      opContent: "您提交了订单，请及时支付",
      isShow: 1
    };
    await this.flowlogDao.create(orderLog, t);
    var orderProductObj = {
      uapp_id: pobj.appInfo.uapp_id,
      sourceOrderNo: orderNo,   // 来源单号
      productType_id: actionBody.product_info.productType_id,//产品类型Id
      pathCode: actionBody.product_info.path_code,//产品路径
      itemCode: actionBody.product_info.item_code,//产品编码
      itemName: actionBody.product_info.item_name,//产品名称                                               
      channelItemCode: actionBody.product_info.channel_item_code,//  渠道产品编码                                                 
      channelItemName: actionBody.product_info.channel_item_name,//  渠道产品名称 
      serviceItemCode: actionBody.product_info.service_item_code,//  服务商产品编码
      picUrl: actionBody.product_info.pic_url,//  产品图片地址      
      proPrice: actionBody.totalSum,    //  产品总价格    
      quantity: actionBody.quantity,//  订单数量（即产品的倍数，默认值为1）   
      opPayType: "00",//  操作付款类型:00: 创建订单, 10: 补单
      serviceItemSnapshot: JSON.stringify(actionBody.product_info),      //产品快照  
    };
    var orderProduct = await this.orderproductDao.create(orderProductObj, t);//订单产品 
    var orderReceiptVoucherObj = {
      uapp_id: pobj.appInfo.uapp_id,
      sourceOrderNo: orderNo,   // 来源单号
      accountType: "other",
      payDate: payTime,//支付时间
      totalSum: actionBody.payTotalSum || actionBody.totalSum,//订单总额
      auditStatus: "dsh",
      wxPayOrderCode: orderNo,//业务微信支付订单号
      aliPayOrderCode: orderNo,//业务支付宝支付订单号
      busPayOrderCode: orderNo,//业务支付订单号

      // payOrderNo: DataTypes.STRING, //支付凭证流水单号，如：微信支付凭证单号
      // buyerOpenId: DataTypes.STRING,//用户在支付商户appid下的唯一标识或买家在支付宝的用户id
      // passTradeNo: DataTypes.STRING,//通道的统一订单号
      // buyerAliLogonId: DataTypes.STRING,//买家支付宝账号
      // certifyFileUrl: order.orderNo, //支付证明文件Url
    };
    if (channelOrder.orderStatus && channelOrder.orderStatus == 2) {//订单状态: 1: 待付款, 2: 已付款, 4: 待服务, 8: 已完成
      var moneyObj = {
        uapp_id: pobj.appInfo.uapp_id,
        sourceOrderNo: orderNo,   // 来源单号
        channelUserId: pobj.userInfo.channel_userid,
        ownerUserId: pobj.userInfo.channel_userid,
        accountType: "other",//帐户类型（ 支付类型）:"cash": "现金", "bank": "银行" ,"wx":"微信","alipay":"支付宝","other":"其它"
        directionType: "sr",//凭单类型,"sr": "收","zc": "支"
        voucherDate: payTime,//凭单时间
        recvAmount: actionBody.payTotalSum || actionBody.totalSum,//收总额
        sourceType: "orderinfo",//来源类型 "orderinfo": "订单","expensevoucher": "费用单"
        auditStatus: "tg",//审核状态"dsh": "待审核", "btg": "不通过", "tg": "通过"
      };
      var moneyJourney = await this.moneyJourneyDao.create(moneyObj, t);
      orderReceiptVoucherObj.auditStatus = "tg";
    }
    if (orderContact && orderContact.mobile) {
      var customerContactObj = {
        uapp_id: pobj.appInfo.uapp_id,//int(11)       //  
        sourceOrderNo: orderNo,//交付订单号   
        contacts: orderContact.contacts || "",//手机号 
        mobile: orderContact.mobile,//手机号
        email: orderContact.email || ""
      };
      await this.ordercontactsDao.create(customerContactObj, t);
    }//渠道购买存在购买者手机号
    var orderReceiptVoucher = await this.orderReceiptVoucherDao.create(orderReceiptVoucherObj, t);
  }
  /**
   * 创建商标订单
   * @param {*} pobj
   * {
          "actionType": "addOrder",
          "actionBody": {
            "channelItemCode":"zzsbzc",
            "id":1,
            "quantity":1,
            "totalSum":300,
            "channelOrder":null,
            "deliveryData":null
          }
      }
   */
  async createTmOrder(pobj) {
    var packagingTmResult = await this.packagingTmDeliveryData(pobj, pobj.actionBody);
    if (packagingTmResult.status != 0) {
      return packagingTmResult;
    }
    var self = this;
    return await self.db.transaction(async function (t) {
      var orderNo = await self.getBusUid("tm" + pobj.appInfo.uapp_id);
      var item = await self.createOrder(pobj, orderNo, t);
      var sql = "INSERT INTO  `c_order_delivery` (`sourceOrderNo`,`deliveryContent`) VALUE('" +
        orderNo + "','" + JSON.stringify(pobj.actionBody.deliveryData) + "')";
      self.customQuery(sql);

      return system.getResultSuccess({
        orderNo: orderNo,
        channelServiceNo: pobj.actionBody.channelOrder.channelServiceNo || orderNo,
        channelOrderNo: pobj.actionBody.channelOrder.channelOrderNo || orderNo,
        channelParams: pobj.actionBody.channelOrder.channelParams || ""
      });
    });
  }

  async packagingTmDeliveryData(pobj, actionBody) {//重新组装商标交付信息
    if (Object.keys(actionBody.deliveryData).length == 0) {
      return system.getResultSuccess();
    }
    if (Number(actionBody.totalSum) < 300) {
      return "总价有误，总价不能小于300，20140";
    }
    var deliveryData = actionBody.deliveryData;
    if (!deliveryData.nclones) {
      return "商品/服务项不能为空，20150";
    }
    if (!deliveryData.tm) {
      return "商标信息不能为空，20180";
    }
    if (!deliveryData.tm.tmName) {
      return "商标名称不能为空，20180";
    }
    if (!deliveryData.tm.picUrl) {
      return "商标图样不能为空，20210";
    }
    if (!deliveryData.apply) {
      return "申请信息不能为空，20230";
    }
    if (!deliveryData.apply.code) {
      return "申请统一社会信用代码不能为空，20250";
    }
    if (!deliveryData.apply.zipCode) {
      return "申请邮编不能为空，20280";
    }
    if (!deliveryData.apply.customerType) {
      return "申请人类型不能为空，20310";
    }
    if (deliveryData.apply.customerType != "ent" && deliveryData.apply.customerType != "person") {
      return "申请人类型错误，20330";
    }
    var deliveryStatus = "dsccl";
    var deliveryStatusName = "待上传材料";
    if (deliveryData.apply.customerType == "ent") {
      if (deliveryData.apply.businessLicensePdf && deliveryData.apply.gzwtsUrl) {
        deliveryStatus = "dsh";
        deliveryStatusName = "待审核";
      }
    } else {
      if (deliveryData.apply.businessLicensePdf && deliveryData.apply.gzwtsUrl && deliveryData.apply.identityCardPdf) {
        deliveryStatus = "dsh";
        deliveryStatusName = "待审核";
      }
    }
    var price_item = actionBody.product_info.price_item;
    var self = this;
    var nclList = [];
    for (let index = 0; index < deliveryData.nclones.length; index++) {
      var nclones = deliveryData.nclones[index];
      var nclThree = nclones.nclThree;
      var tempNclones = {
        ncloneCode: nclones.code,
        ncloneName: nclones.name,
        nclThree: nclThree,
        nclCount: nclThree.length,
        nclPublicExpense: Number(price_item.price) * nclThree.length,
        deliveryStatus: deliveryStatus,//商标交付状态
        deliveryStatusName: deliveryStatusName,
        submitTime: "",
        deliveryType: pobj.appInfo.delivery_type,//应用数据操作类型：00独立，10全委托
        tbCode: await self.getBusUid("tb" + pobj.appInfo.uapp_id)//提报号(自动生成)
      }
      nclList.push(tempNclones);
    }
    pobj.actionBody.deliveryData.nclList = nclList;
    delete pobj.actionBody.deliveryData["nclones"];
    return system.getResultSuccess();
  }

   //   caseService   拟开展服务项目  多 必
  // caseCustomerType   目标用户   多 必
  // caseProfitType    盈利模式   多 必
  // caseApprovalProgram  需专项审批的项目  多 
  // //caseApprovalProgramName  需专项审批的项目
  // //caseApprovalProgramUrl  需专项审批的项目文件
  // caseWeb 网站或APP情况  
  // caseWebName 网站或APP情况名称      必
  // caseApp 网站或APP情况
  // caseAppName 网站或APP情况名称
  // caseWebCertificateUrl  公司域名证书 必
  // caseTMCertificateUrl  公司商标证书  必


  // 必
  // apDxProgramType   申请的电信业务种类 默认
  // apProgramScope   申请的业务覆盖范围  默认
  // apCompany 公司名称  
  // apCompanyCode 企业统一社会信用代码
  // apCompanyRegCapital 注册资本
  // apCompanyRegAddr  注册地址
  // apCompanyTel  公司固定电话
  // apCompanyLicenseurl 企业法人营业执照
  // apCompanyWorkAddr  主要办公地址
  // apCompanyType  公司性质


  // 必
  // companyCate  公司目前主营业务所属行业
  // companyPersonnelNum 公司现有人员规模
  // companyBusinessScope  公司经营规模
  // companyLegalpersonName 法定代表人姓名
  // companyLpCertificateCode 法定代表人证件号
  // companyLpCertificateType 法定代表人证件类型
  // companyLpPhone 法定代表人手机
  // companyLpEmail 法定代表人邮箱
  // companyLpCertificateUrl  法定代表人身份证

  // companyLicenserName  许可负责人姓名
  // companyLoCertificateCode 许可负责人证件号
  // companyLoCertificateType 许可负责人证件类型
  // companyLoPhone 许可负责人手机
  // companyLoEmail 许可负责人邮箱
  // companyLoCertificateUrl  许可负责人身份证

  // companyCsName  客服负责人姓名
  // companyCsCertificateCode 客服负责人证件号
  // companyCsCertificateType 客服负责人证件类型
  // companyCsPhone 客服负责人手机
  // companyCsEmail 客服负责人邮箱
  // companyCsCertificateUrl  客服负责人身份证

  // companySafetyName  安全负责人姓名
  // companySfCertificateCode 安全负责人证件号
  // companySfCertificateType 安全负责人证件类型
  // companySfPhone 安全负责人手机
  // companySfEmail 安全负责人邮箱
  // companySfCertificateUrl  安全负责人身份证
  // shebaoCertificateUrl  社保证明




  // webSafetyOrginfo 网络与信息安全管理组织机构设置及工作职责  必
  // webSafetyPersonnel    网络与信息安全管理人员配备情况及其相应资质  必

  // shareholderCommitUrl 股东追溯不涉及外资承诺书    必
  // shareholderInfo 股东股权情况   多 必
  //  shareholderName  股东名称
  //  shareholderShareratio  股权比例
  // applicantInfo 申请者《国家企业《信用信息公示系统截图》   多 必

  // commitUrl 承诺书  必

  // otherCaseUrl  收费方案或其他
  // otherIDCCertificateUrl  托管协议及托管商IDC证书  多 必

  async createICPOrder(pobj) {

    // var packagingICPResult = await this.packagingICPDeliveryData(pobj, pobj.actionBody);
    // if (packagingICPResult.status != 0) {
    //   return packagingICPResult;
    // }
    var self = this;
    return await self.db.transaction(async function (t) {

      var sql = "";
      var orderNo = "";
      if (pobj.actionBody.orderNo) {
        orderNo = pobj.actionBody.orderNo;
        sql = "update c_order_delivery set  deliveryContent='" + JSON.stringify(pobj.actionBody.deliveryData) + "' where sourceOrderNo='" +
          orderNo + "'";
      } else {
        var orderNo = await self.getBusUid("icp" + pobj.appInfo.uapp_id);
        var item = await self.createOrder(pobj, orderNo, t);
        sql = "INSERT INTO  `c_order_delivery` (`sourceOrderNo`,`deliveryContent`) VALUE('" +
          orderNo + "','" + JSON.stringify(pobj.actionBody.deliveryData) + "')";
      }
      self.customQuery(sql);

      return system.getResultSuccess({
        orderNo: orderNo,
        channelServiceNo: pobj.actionBody.channelOrder.channelServiceNo || orderNo,
        channelOrderNo: pobj.actionBody.channelOrder.channelOrderNo || orderNo,
        channelParams: pobj.actionBody.channelOrder.channelParams || ""
      });
    });
  }

  async packagingICPDeliveryData(pobj, actionBody) {//重新组装商标交付信息
    if (actionBody.pageNum) {
      return "表单参数错误";
    }
    if (Number(actionBody.totalSum) < 300) {
      return "总价有误，总价不能小于300，20140";
    }
    var deliveryData = actionBody.deliveryData;
    if (!deliveryData.nclones) {
      return "商品/服务项不能为空，20150";
    }
    if (!deliveryData.tm) {
      return "商标信息不能为空，20180";
    }
    if (!deliveryData.tm.tmName) {
      return "商标名称不能为空，20180";
    }
    if (!deliveryData.tm.picUrl) {
      return "商标图样不能为空，20210";
    }
    if (!deliveryData.apply) {
      return "申请信息不能为空，20230";
    }
    if (!deliveryData.apply.code) {
      return "申请统一社会信用代码不能为空，20250";
    }
    if (!deliveryData.apply.zipCode) {
      return "申请邮编不能为空，20280";
    }
    if (!deliveryData.apply.customerType) {
      return "申请人类型不能为空，20310";
    }
    if (deliveryData.apply.customerType != "ent" && deliveryData.apply.customerType == "person") {
      return "申请人类型错误，20330";
    }
    var deliveryStatus = "dsccl";
    var deliveryStatusName = "待上传材料";
    if (deliveryData.apply.customerType == "ent") {
      if (deliveryData.apply.businessLicensePdf && deliveryData.apply.gzwtsUrl) {
        deliveryStatus = "dsh";
        deliveryStatusName = "待审核";
      }
    } else {
      if (deliveryData.apply.businessLicensePdf && deliveryData.apply.gzwtsUrl && deliveryData.apply.identityCardPdf) {
        deliveryStatus = "dsh";
        deliveryStatusName = "待审核";
      }
    }
    var price_item = actionBody.product_info.price_item;
    var self = this;
    var nclList = [];
    for (let index = 0; index < deliveryData.nclones.length; index++) {
      var nclones = deliveryData.nclones[index];
      var nclThree = nclones.nclThree;
      var tempNclones = {
        ncloneCode: nclones.code,
        ncloneName: nclones.name,
        nclThree: nclThree,
        nclCount: nclThree.length,
        nclPublicExpense: Number(price_item.price) * nclThree.length,
        deliveryStatus: deliveryStatus,//商标交付状态
        deliveryStatusName: deliveryStatusName,
        submitTime: "",
        deliveryType: pobj.appInfo.delivery_type,//应用数据操作类型：00独立，10全委托
        tbCode: await self.getBusUid("tb" + pobj.appInfo.uapp_id)//提报号(自动生成)
      }
      nclList.push(tempNclones);
    }
    pobj.actionBody.deliveryData.nclList = nclList;
    delete pobj.actionBody.deliveryData["nclones"];
    return system.getResultSuccess();
  }

  /**
   * 创建其他订单
   * @param {*} pobj  
   */
  async createOtherOrder(pobj) {
    var self = this;
    return await self.db.transaction(async function (t) {
      var orderNo = await self.getBusUid("ot" + pobj.appInfo.uapp_id);
      var item = await self.createOrder(pobj, orderNo, t);
      return system.getResultSuccess({
        orderNo: orderNo,
        channelServiceNo: pobj.actionBody.channelOrder.channelServiceNo || orderNo,
        channelOrderNo: pobj.actionBody.channelOrder.channelOrderNo || orderNo,
        channelParams: pobj.actionBody.channelOrder.channelParams || ""
      });
    });

  }

  async createChannelSource(pobj) {//创建渠道来源订单
    var orderNo = await self.getBusUid("oc" + pobj.appInfo.uapp_id);
    // var beforeOrder = await this.dao.model.findOne({
    //   where: { channelServiceNo: channelOrder.channelServiceNo, uapp_id: app.uAppId },
    //   raw: true
    // });
    // if (beforeOrder) {//订单已存在
    //   return system.getResultFail(2, "订单已存在", beforeOrder.orderNo);
    // }
  }
  /**
   * 获取付款订单信息
   * @param {*} pobj 
   * @param {*} actionBody {orderNo:XXXX}
   */
  async getPayOrderInfo(pobj, actionBody) {
    var productItem = await this.orderproductDao.getItemByOrderNo(actionBody.orderNo, pobj.appInfo.uapp_id);
    if (!productItem) {
      return system.getResult(null, "订单产品数据异常，30050");
    }
    var item = await this.orderReceiptVoucherDao.getItemByOrderNo(actionBody.orderNo, pobj.appInfo.uapp_id);
    if (!item) {
      return system.getResult(null, "订单已经付款成功，请勿重复支付，30010");
    }
    var param = {
      receiptVoucher: item,
      orderProduct: productItem
    }
    return system.getResultSuccess(param);
  }
  /**
   * 修改订单收款信息
   * @param {*} pobj 
   * @param {*} actionBody {orderNo:XXXX,trxid:XXX--支付流水号,isPut:1---大于0则进行修改操作,setField:{XXXXX}---修改的字段,receiptVoucherId:XX--收款Id,opType:"wx"}---"wx":"微信","alipay":"支付宝"
   */
  async putReceiptVoucherInfo(pobj, actionBody) {
    var isPut = actionBody.isPut || "";
    if (isPut > 0) {
      await this.orderReceiptVoucherDao.updateByWhere(actionBody.setField, { where: { id: actionBody.receiptVoucherId } });
    }
    return system.getResultSuccess();
  }

  async getOrderInfo(pobj, actionBody) {//获取订单列表信息
    var pageSize = Number(actionBody.pageSize || 20);
    if (pageSize > 50) {
      pageSize = 50;
    }
    var pageIndex = Number(actionBody.pageIndex || 1);
    var from = pageIndex == 1 ? 0 : Number((pageIndex - 1) * pageSize);

    var paramWhere = {};
    var sql = "select `orderNo`,`channelServiceNo`,`channelOrderNo`,`channelUserId`,`ownerUserId`,`payTime`,`quantity`,`serviceQuantity`,`orderStatusName`,`orderStatus`,`totalSum`,`payTotalSum`,`refundSum`,"
      + " `invoiceApplyStatus`,`opNotes`,`channelItemCode`,`channelItemName`,`serviceItemCode`,`picUrl`,created_at from v_order where uapp_id=:uapp_id";
    var sqlCount = "select count(1) as dataCount from v_order where uapp_id=:uapp_id";

    paramWhere.uapp_id = pobj.appInfo.uapp_id;
    if (pobj.userInfo.channel_userid) {
      sql += " and channelUserId=:channelUserId";
      sqlCount += " and channelUserId=:channelUserId";
      paramWhere.channelUserId = pobj.userInfo.channel_userid;
    }
    if (actionBody.channelItemName) {
      sql += " and channelItemName like :channelItemName";
      sqlCount += " and channelItemName like :channelItemName";
      paramWhere.channelItemName = "%" + params.channelItemName.trim() + "%";
    }
    if (actionBody.channelServiceNo) {
      sql += " and channelServiceNo like :channelServiceNo";
      sqlCount += " and channelServiceNo like :channelServiceNo";
      paramWhere.channelServiceNo = "%" + actionBody.channelServiceNo.trim() + "%";
    }
    if (actionBody.orderStatus) {
      sql += " and orderStatus=:orderStatus";
      sqlCount += " and orderStatus=:orderStatus";
      paramWhere.orderStatus = actionBody.orderStatus;
    }
    if (actionBody.startTime && actionBody.entTime) {
      var startTime = actionBody.startTime.trim() + " 00:00:00";
      var entTime = actionBody.entTime + " 23:59:59";
      sql += " and created_at >=:startTime and  created_at<=:entTime";
      sqlCount += " and created_at >=:startTime and  created_at<=:entTime";
      paramWhere.startTime = startTime;
      paramWhere.entTime = entTime;
    }

    sql += " LIMIT " + pageSize + " OFFSET " + from;

    var list = await this.customQuery(sql, paramWhere);
    var result = system.getResultSuccess(list);

    var tmpResultCount = await this.customQuery(sqlCount, paramWhere);

    result.dataCount = tmpResultCount && tmpResultCount.length > 0 ? tmpResultCount[0].dataCount : 0;

    return result;

  }

  async getOrderDeliveryInfo(pobj, actionBody) {//获取订单交付信息
    var sql = "select * from c_order_delivery where sourceOrderNo=:sourceOrderNo";
    var paramWhere = { sourceOrderNo: actionBody.orderNo };
    var list = await this.customQuery(sql, paramWhere);
    if (list && list.length > 0) {
      if (list[0].deliveryContent) {
        return system.getResultSuccess(list[0].deliveryContent);
      }
    }
    return system.getResultSuccess();
  }

  async getOrderDeliveryFlowInfo(pobj, actionBody) {//获取订单交付流程信息
    var sql = "select * from c_delivery_official_flow where sourceOrderNo=:sourceOrderNo";
    var paramWhere = { sourceOrderNo: actionBody.sourceOrderNo };
    var list = await this.customQuery(sql, paramWhere);
    if (list && list.length > 0) {
      if (list[0].officialFlow) {
        return system.getResultSuccess(list[0].officialFlow);
      }
    }
    return system.getResultSuccess();
  }
  async getOrderDeliveryFlowList(pobj, actionBody) {//获取订单交付流程列表信息
    var sql = "select * from c_delivery_official_flow where sourceOrderNo IN(:sourceOrderNo)";
    var paramWhere = { sourceOrderNo: actionBody.sourceOrderNoList };
    var list = await this.customQuery(sql, paramWhere);
    var tmpList = [];
    if (list && list.length > 0) {
      for (let index = 0; index < list.length; index++) {
        const element = list[index];
        if (element.officialFlow) {
          tmpList.push({
            sourceOrderNo: element.sourceOrderNo,
            flowList: element.officialFlow
          });
        }
      }
    }
    return system.getResultSuccess(tmpList);
  }
  async getOrderLogInfo(pobj, actionBody) {//获取订单日志信息
    var list = await this.flowlogDao.getlogListBySourceOrderNo(actionBody.sourceOrderNo);
    return system.getResultSuccess(list);
  }
  //-------------------------------服务商通知订单流程-------------start----------------

  async icOrderStatusNotify(pobj, actionBody) {//峰擎通知工商办理状态
    var item = await this.dao.getItemStatusByOrderNo(actionBody.orderNo);
    if (!item) {
      return system.getResult(null, "order data is empty!");
    }
    if (Number(item.orderStatus) == 1) {
      return system.getResult(null, "order status is  unpay!");
    }
    var updateDeliveryInfo = {
      orderDeliveryStatus: actionBody.orderDeliveryStatus,
      orderDeliveryStatusName: actionBody.orderDeliveryStatusName,
      updated: actionBody.updated,
      flowList: []
    };
    pobj.actionBody.sourceOrderNo = actionBody.orderNo;
    var deliveryInfo = await this.getOrderDeliveryFlowInfo(pobj);
    var addi = 0;
    if (deliveryInfo.status == 0 && deliveryInfo.data && deliveryInfo.data.flowList.length > 0) {
      updateDeliveryInfo.flowList = deliveryInfo.data.flowList;
    } else {
      updateDeliveryInfo = {
        orderDeliveryStatus: "已下单",
        orderDeliveryStatusName: "已下单",
        updated: item.created_at,
        flowList: [{
          orderDeliveryStatus: "已下单",
          orderDeliveryStatusName: "已下单",
          updated: item.created_at
        }]
      };
      addi = 1;
    }
    updateDeliveryInfo.updated = actionBody.updated;
    updateDeliveryInfo.orderDeliveryStatus = actionBody.orderDeliveryStatus;
    var tempList = actionBody.orderDeliveryStatusName.split('-');
    updateDeliveryInfo.orderDeliveryStatusName = tempList[tempList.length - 1];

    var dataIndex = updateDeliveryInfo.flowList.findIndex(f => f.orderDeliveryStatus == actionBody.orderDeliveryStatus);
    if (dataIndex > -1) {
      updateDeliveryInfo.flowList[dataIndex].orderDeliveryStatusName = actionBody.orderDeliveryStatusName;
      updateDeliveryInfo.flowList[dataIndex].updated = actionBody.updated;
    } else {
      updateDeliveryInfo.flowList.push({
        orderDeliveryStatus: actionBody.orderDeliveryStatus,
        orderDeliveryStatusName: actionBody.orderDeliveryStatusName,
        updated: actionBody.updated
      });
    }
    var orderLog = {
      uapp_id: item.uapp_id,
      sourceOrderNo: actionBody.orderNo,
      created_at: actionBody.updated,
      opContent: "您的订单办理流程更新为【" + updateDeliveryInfo.orderDeliveryStatusName + "】",
      isShow: 1
    };
    await this.flowlogDao.create(orderLog);
    var sql = null;
    if (addi > 0) {
      await this.dao.updateByWhere({ orderStatus: 4 }, { where: { id: item.id } });
      sql = "INSERT INTO  `c_delivery_official_flow` (`sourceOrderNo`,`officialFlow`) VALUE('" +
        actionBody.orderNo + "','" + JSON.stringify(updateDeliveryInfo) + "')";
    }
    else {
      if (updateDeliveryInfo.orderDeliveryStatusName == "证件邮寄环节") {
        await this.dao.updateByWhere({ orderStatus: 8 }, { where: { id: item.id } });
      }
      sql = "UPDATE `c_delivery_official_flow`  SET officialFlow ='" + JSON.stringify(updateDeliveryInfo) + "' where sourceOrderNo='" + actionBody.orderNo + "'";
    }
    this.customQuery(sql);
    return system.getResultSuccess();
  }


  //-------------------------------服务商通知订单流程-------------end----------------

}
module.exports = OrderInfoService;